diff --git a/usr.sbin/ac/ac.c b/usr.sbin/ac/ac.c
index ab26011..3a5fabf 100644
--- a/usr.sbin/ac/ac.c
+++ b/usr.sbin/ac/ac.c
@@ -501,7 +501,7 @@ ac(FILE *fp)
 	}
 	fclose(fp);
 	if (!(Flags & AC_W))
-		usr.ut_time = time((time_t *)0);
+		usr.ut_time = time(NULL);
 	strcpy(usr.ut_line, "~");
 
 	if (Flags & AC_D) {
@@ -523,7 +523,7 @@ ac(FILE *fp)
 	head = log_out(head, &usr);
 
 	if (Flags & AC_D)
-		show_today(Users, head, time((time_t *)0));
+		show_today(Users, head, time(NULL));
 	else {
 		if (Flags & AC_P)
 			show_users(Users);
diff --git a/usr.sbin/atm/atmarpd/atmarp_config.c b/usr.sbin/atm/atmarpd/atmarp_config.c
index 34ee7be..d1e085f 100644
--- a/usr.sbin/atm/atmarpd/atmarp_config.c
+++ b/usr.sbin/atm/atmarpd/atmarp_config.c
@@ -78,7 +78,7 @@ int
 atmarp_cfg_netif(char *netif)
 {
 	int			rc;
-	Atmarp_intf		*aip = (Atmarp_intf *)0;
+	Atmarp_intf		*aip = NULL;
 
 	/*
 	 * Get an ATMARP interface block
diff --git a/usr.sbin/atm/atmarpd/atmarp_scsp.c b/usr.sbin/atm/atmarpd/atmarp_scsp.c
index 3330b83..371e783 100644
--- a/usr.sbin/atm/atmarpd/atmarp_scsp.c
+++ b/usr.sbin/atm/atmarpd/atmarp_scsp.c
@@ -80,7 +80,7 @@ atmarp_scsp_cache(Atmarp_intf *aip, Scsp_if_msg *msg)
 {
 	int		i, len, rc = 0;
 	Atmarp		*aap;
-	Scsp_if_msg	*smp = (Scsp_if_msg *)0;
+	Scsp_if_msg	*smp = NULL;
 	Scsp_atmarp_msg	*sap;
 
 	/*
@@ -160,7 +160,7 @@ atmarp_scsp_solicit(Atmarp_intf *aip, Scsp_if_msg *smp)
 {
 	int		i, rc = 0;
 	Atmarp		*aap;
-	Scsp_if_msg	*rsp = (Scsp_if_msg *)0;
+	Scsp_if_msg	*rsp = NULL;
 
 	/*
 	 * Search the interface's ATMARP cache for an entry with
@@ -245,7 +245,7 @@ atmarp_scsp_update(Atmarp *aap, int state)
 {
 	int		rc = 0;
 	Atmarp_intf	*aip = aap->aa_intf;
-	Scsp_if_msg	*smp = (Scsp_if_msg *)0;
+	Scsp_if_msg	*smp = NULL;
 
 	/*
 	 * Make sure the connection to SCSP is active
@@ -441,7 +441,7 @@ int
 atmarp_scsp_read(Atmarp_intf *aip)
 {
 	int		len, rc = 0;
-	char		*buff = (char *)0;
+	char		*buff = NULL;
 	Scsp_if_msg	*smp;
 	Scsp_if_msg_hdr	msg_hdr;
 
@@ -763,7 +763,7 @@ atmarp_scsp_disconnect(Atmarp_intf *aip)
 		for (aap = aip->ai_arptbl[i]; aap; aap = aap->aa_next) {
 			UM_FREE(aap);
 		}
-		aip->ai_arptbl[i] = (Atmarp *)0;
+		aip->ai_arptbl[i] = NULL;
 	}
 
 	return(0);
diff --git a/usr.sbin/atm/atmarpd/atmarp_subr.c b/usr.sbin/atm/atmarpd/atmarp_subr.c
index 03ec5d7..6293412 100644
--- a/usr.sbin/atm/atmarpd/atmarp_subr.c
+++ b/usr.sbin/atm/atmarpd/atmarp_subr.c
@@ -213,10 +213,10 @@ int
 atmarp_if_ready(Atmarp_intf *aip)
 {
 	int			i, len, mtu, rc, sel;
-	Atmarp			*aap = (Atmarp *)0;
+	Atmarp			*aap = NULL;
 	struct atminfreq	air;
-	struct air_netif_rsp	*netif_rsp = (struct air_netif_rsp *)0;
-	struct air_int_rsp	*intf_rsp = (struct air_int_rsp *)0;
+	struct air_netif_rsp	*netif_rsp = NULL;
+	struct air_int_rsp	*intf_rsp = NULL;
 	struct sockaddr_in	*ip_addr;
 	struct sockaddr_in	subnet_mask;
 	Atm_addr_nsap		*anp;
@@ -438,10 +438,10 @@ atmarp_copy_cache_entry(struct air_arp_rsp *cp)
 	 * Sanity checks
 	 */
 	if (!cp)
-		return((Atmarp *)0);
+		return(NULL);
 	aip = atmarp_find_intf_name(cp->aap_intf);
 	if (!aip)
-		return((Atmarp *)0);
+		return(NULL);
 
 	/*
 	 * Get a new cache entry
@@ -449,7 +449,7 @@ atmarp_copy_cache_entry(struct air_arp_rsp *cp)
 	aap = (Atmarp *)UM_ALLOC(sizeof(Atmarp));
 	if (!aap) {
 		errno = ENOMEM;
-		return((Atmarp *)0);
+		return(NULL);
 	}
 	UM_ZERO(aap, sizeof(Atmarp));
 	aap->aa_intf = aip;
@@ -912,7 +912,7 @@ atmarp_sigint(int sig)
 	 * Open the output file
 	 */
 	df = fopen(fname, "w");
-	if (df == (FILE *)0)
+	if (df == NULL)
 		return;
 
 	/*
diff --git a/usr.sbin/atm/atmarpd/atmarpd.c b/usr.sbin/atm/atmarpd/atmarpd.c
index d758e5c..8c27fa1 100644
--- a/usr.sbin/atm/atmarpd/atmarpd.c
+++ b/usr.sbin/atm/atmarpd/atmarpd.c
@@ -70,10 +70,10 @@
 char		*prog;
 int		atmarp_debug_mode = 0;
 int		atmarp_max_socket = 0;
-Atmarp_intf	*atmarp_intf_head = (Atmarp_intf *)0;
-Atmarp_slis	*atmarp_slis_head = (Atmarp_slis *)0;
-FILE		*atmarp_log_file = (FILE *)0;
-char		*atmarp_log_file_name = (char *)0;
+Atmarp_intf	*atmarp_intf_head = NULL;
+Atmarp_slis	*atmarp_slis_head = NULL;
+FILE		*atmarp_log_file = NULL;
+char		*atmarp_log_file_name = NULL;
 Harp_timer	cache_timer, perm_timer;
 
 
@@ -243,7 +243,7 @@ start_daemon(void)
 	}
 	fd = open(_PATH_TTY, O_RDWR);
 	if (fd >= 0) {
-		ioctl(fd, TIOCNOTTY, (char *)0);
+		ioctl(fd, TIOCNOTTY, NULL);
 		close(fd);
 	}
 
@@ -375,7 +375,7 @@ main(int argc, char **argv)
 		}
 		rc = select(atmarp_max_socket + 1,
 				&read_set, &write_set,
-				&except_set, (struct timeval *)0);
+				&except_set, NULL);
 		if (rc < 0) {
 			if (harp_timer_exec) {
 				timer_proc();
diff --git a/usr.sbin/atm/scspd/scsp_cafsm.c b/usr.sbin/atm/scspd/scsp_cafsm.c
index 90abe90..efa2e60 100644
--- a/usr.sbin/atm/scspd/scsp_cafsm.c
+++ b/usr.sbin/atm/scspd/scsp_cafsm.c
@@ -207,8 +207,7 @@ scsp_ca_act_00(Scsp_dcs *dcsp, void *p)
 	/*
 	 * Notify the client I/F FSM
 	 */
-	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_DOWN, (Scsp_msg *)0,
-			(Scsp_if_msg *)0);
+	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_DOWN, NULL, NULL);
 
 	return(rc);
 }
@@ -255,7 +254,7 @@ scsp_ca_act_01(Scsp_dcs *dcsp, void *p)
 	/*
 	 * Select an initial sequence number
 	 */
-	dcsp->sd_ca_seq = (int)time((time_t *)0);
+	dcsp->sd_ca_seq = (int)time(NULL);
 
 	/*
 	 * Send a CA message
@@ -301,8 +300,7 @@ scsp_ca_act_02(Scsp_dcs *dcsp, void *p)
 	/*
 	 * Notify the client I/F FSM
 	 */
-	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_DOWN, (Scsp_msg *)0,
-			(Scsp_if_msg *)0);
+	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_DOWN, NULL, NULL);
 
 	return(rc);
 }
@@ -346,8 +344,7 @@ scsp_ca_act_03(Scsp_dcs *dcsp, void *p)
 		 * Set the new state
 		 */
 		dcsp->sd_ca_state = SCSP_CAFSM_SLAVE;
-		scsp_cfsm(dcsp, SCSP_CIFSM_CA_SUMM,
-				(Scsp_msg *)0, (Scsp_if_msg *)0);
+		scsp_cfsm(dcsp, SCSP_CIFSM_CA_SUMM, NULL, NULL);
 
 		/*
 		 * Save the master's sequence number
@@ -375,8 +372,7 @@ scsp_ca_act_03(Scsp_dcs *dcsp, void *p)
 		 * Set the new state
 		 */
 		dcsp->sd_ca_state = SCSP_CAFSM_MASTER;
-		rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_SUMM,
-				(Scsp_msg *)0, (Scsp_if_msg *)0);
+		rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_SUMM, NULL, NULL);
 
 		/*
 		 * Process the CA message
@@ -439,7 +435,7 @@ scsp_ca_act_04(Scsp_dcs *dcsp, void *p)
 		HARP_CANCEL(&dcsp->sd_ca_rexmt_t);
 		dcsp->sd_ca_state = SCSP_CAFSM_NEG;
 		scsp_dcs_cleanup(dcsp);
-		return(scsp_ca_act_01(dcsp, (Scsp_msg *)0));
+		return(scsp_ca_act_01(dcsp, NULL));
 	}
 
 	/*
@@ -475,7 +471,7 @@ scsp_ca_act_04(Scsp_dcs *dcsp, void *p)
 		 */
 		if (dcsp->sd_ca_rexmt_msg) {
 			scsp_free_msg(dcsp->sd_ca_rexmt_msg);
-			dcsp->sd_ca_rexmt_msg = (Scsp_msg *)0;
+			dcsp->sd_ca_rexmt_msg = NULL;
 		}
 
 		/*
@@ -487,17 +483,13 @@ scsp_ca_act_04(Scsp_dcs *dcsp, void *p)
 			 * Go to Aligned state
 			 */
 			dcsp->sd_ca_state = SCSP_CAFSM_ALIGNED;
-			rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_ALIGN,
-					(Scsp_msg *)0,
-					(Scsp_if_msg *)0);
+			rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_ALIGN, NULL, NULL);
 		} else {
 			/*
 			 * Go to Cache Update state
 			 */
 			dcsp->sd_ca_state = SCSP_CAFSM_UPDATE;
-			scsp_cfsm(dcsp, SCSP_CIFSM_CA_UPD,
-					(Scsp_msg *)0,
-					(Scsp_if_msg *)0);
+			scsp_cfsm(dcsp, SCSP_CIFSM_CA_UPD, NULL, NULL);
 			rc = scsp_send_csus(dcsp);
 		}
 	} else {
@@ -543,7 +535,7 @@ scsp_ca_act_05(Scsp_dcs *dcsp, void *p)
 		HARP_CANCEL(&dcsp->sd_ca_rexmt_t);
 		dcsp->sd_ca_state = SCSP_CAFSM_NEG;
 		scsp_dcs_cleanup(dcsp);
-		return(scsp_ca_act_01(dcsp, (Scsp_msg *)0));
+		return(scsp_ca_act_01(dcsp, NULL));
 	}
 
 	/*
@@ -566,7 +558,7 @@ scsp_ca_act_05(Scsp_dcs *dcsp, void *p)
 	 */
 	if (dcsp->sd_ca_rexmt_msg) {
 		scsp_free_msg(dcsp->sd_ca_rexmt_msg);
-		dcsp->sd_ca_rexmt_msg = (Scsp_msg *)0;
+		dcsp->sd_ca_rexmt_msg = NULL;
 	}
 
 	/*
@@ -600,9 +592,7 @@ scsp_ca_act_05(Scsp_dcs *dcsp, void *p)
 			 * Go to Aligned state
 			 */
 			dcsp->sd_ca_state = SCSP_CAFSM_ALIGNED;
-			rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_ALIGN,
-					(Scsp_msg *)0,
-					(Scsp_if_msg *)0);
+			rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_ALIGN, NULL, NULL);
 		} else {
 			/*
 			 * Go to Cache Update state
@@ -612,9 +602,7 @@ scsp_ca_act_05(Scsp_dcs *dcsp, void *p)
 			HARP_TIMER(&dcsp->sd_ca_rexmt_t,
 					dcsp->sd_ca_rexmt_int,
 					scsp_ca_retran_timeout);
-			scsp_cfsm(dcsp, SCSP_CIFSM_CA_UPD,
-					(Scsp_msg *)0,
-					(Scsp_if_msg *)0);
+			scsp_cfsm(dcsp, SCSP_CIFSM_CA_UPD, NULL, NULL);
 			rc = scsp_send_csus(dcsp);
 		}
 	}
@@ -684,14 +672,13 @@ scsp_ca_act_07(Scsp_dcs *dcsp, void *p)
 	if (dcsp->sd_ca_rexmt_msg) {
 		HARP_CANCEL(&dcsp->sd_ca_rexmt_t);
 		scsp_free_msg(dcsp->sd_ca_rexmt_msg);
-		dcsp->sd_ca_rexmt_msg = (Scsp_msg *)0;
+		dcsp->sd_ca_rexmt_msg = NULL;
 	}
 
 	/*
 	 * Pass the CSUS to the client interface FSM
 	 */
-	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CSU_SOL, msg,
-			(Scsp_if_msg *)0);
+	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CSU_SOL, msg, NULL);
 
 	return(rc);
 }
@@ -729,15 +716,13 @@ scsp_ca_act_08(Scsp_dcs *dcsp, void *p)
 	if (!dcsp->sd_csus_rexmt_msg && !dcsp->sd_crl &&
 			dcsp->sd_ca_state != SCSP_CAFSM_ALIGNED) {
 		dcsp->sd_ca_state = SCSP_CAFSM_ALIGNED;
-		rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_ALIGN,
-				(Scsp_msg *)0, (Scsp_if_msg *)0);
+		rc = scsp_cfsm(dcsp, SCSP_CIFSM_CA_ALIGN, NULL, NULL);
 	}
 
 	/*
 	 * Pass the CSU Req to the client interface FSM
 	 */
-	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CSU_REQ, msg,
-			(Scsp_if_msg *)0);
+	rc = scsp_cfsm(dcsp, SCSP_CIFSM_CSU_REQ, msg, NULL);
 
 	/*
 	 * Move the CSA chain from the message to the list of
@@ -747,7 +732,7 @@ scsp_ca_act_08(Scsp_dcs *dcsp, void *p)
 			csap = csap->next) {
 		LINK2TAIL(csap, Scsp_csa, dcsp->sd_csu_ack_pend, next);
 	}
-	msg->sc_csu_msg->csu_csa_rec = (Scsp_csa *)0;
+	msg->sc_csu_msg->csu_csa_rec = NULL;
 
 	return(rc);
 }
@@ -775,7 +760,7 @@ scsp_ca_act_09(Scsp_dcs *dcsp, void *p)
 	 */
 	if (dcsp->sd_ca_rexmt_msg) {
 		scsp_free_msg(dcsp->sd_ca_rexmt_msg);
-		dcsp->sd_ca_rexmt_msg = (Scsp_msg *)0;
+		dcsp->sd_ca_rexmt_msg = NULL;
 	}
 
 	return(0);
@@ -1188,7 +1173,7 @@ scsp_ca_act_15(Scsp_dcs *dcsp, void *p)
 			msg->sc_ca->ca_seq != dcsp->sd_ca_seq) {
 		dcsp->sd_ca_state = SCSP_CAFSM_NEG;
 		scsp_dcs_cleanup(dcsp);
-		rc = scsp_ca_act_01(dcsp, (Scsp_msg *)0);
+		rc = scsp_ca_act_01(dcsp, NULL);
 	} else {
 		/*
 		 * Retransmit the saved CA message and reset the
@@ -1286,7 +1271,7 @@ scsp_ca_act_16(Scsp_dcs *dcsp, void *p)
 		 * ACK pending list is empty--send a CSU Reply
 		 */
 		csap = dcsp->sd_csu_ack;
-		dcsp->sd_csu_ack = (Scsp_csa *)0;
+		dcsp->sd_csu_ack = NULL;
 		rc = scsp_send_csu_reply(dcsp, csap);
 	}
 
diff --git a/usr.sbin/atm/scspd/scsp_config.c b/usr.sbin/atm/scspd/scsp_config.c
index 97c306a..8e3708c 100644
--- a/usr.sbin/atm/scspd/scsp_config.c
+++ b/usr.sbin/atm/scspd/scsp_config.c
@@ -104,7 +104,7 @@ scsp_config(char *cfn)
 	/*
 	 * Initialize current interface pointer
 	 */
-	current_server = (Scsp_server *)0;
+	current_server = NULL;
 
 	/*
 	 * Clear marks on any existing servers
@@ -244,7 +244,7 @@ finish_dcs(void)
 		rc++;
 	}
 
-	current_dcs = (Scsp_dcs *)0;
+	current_dcs = NULL;
 	return(rc);
 }
 
@@ -1066,7 +1066,7 @@ finish_server(void)
 	/*
 	 * Make sure the interface has been configured
 	 */
-	if (ssp->ss_intf == (char *)0) {
+	if (ssp->ss_intf == NULL) {
 		parse_error("netif missing from server specification");
 		rc++;
 	}
@@ -1090,7 +1090,7 @@ finish_server(void)
 	/*
 	 * Make sure at least one DCS is configured
 	 */
-	if (ssp->ss_dcs == (Scsp_dcs *)0) {
+	if (ssp->ss_dcs == NULL) {
 		parse_error("no DCS configured for server");
 		rc++;
 	}
@@ -1098,7 +1098,7 @@ finish_server(void)
 	/*
 	 * Mark the end of the server
 	 */
-	current_server = (Scsp_server *)0;
+	current_server = NULL;
 
 	return(rc);
 }
diff --git a/usr.sbin/atm/scspd/scsp_config_lex.c b/usr.sbin/atm/scspd/scsp_config_lex.c
index 2879f6c..79ccc48 100644
--- a/usr.sbin/atm/scspd/scsp_config_lex.c
+++ b/usr.sbin/atm/scspd/scsp_config_lex.c
@@ -172,7 +172,7 @@ static struct {
 	{ "server",		TOK_SERVER },
 	{ "ServerGroupID",	TOK_SRVGRP },
 	{ "syslog",		TOK_SYSLOG },
-	{ (char *)0,		0 },
+	{ NULL,			0 },
 };
 
 
diff --git a/usr.sbin/atm/scspd/scsp_config_parse.y b/usr.sbin/atm/scspd/scsp_config_parse.y
index d292d7e..0498927 100644
--- a/usr.sbin/atm/scspd/scsp_config_parse.y
+++ b/usr.sbin/atm/scspd/scsp_config_parse.y
@@ -228,7 +228,7 @@ dcs_spec: /* Nothing */
 		/*
 		 * Set DCS address
 		 */
-		rc = set_dcs_addr($2, (char *)0);
+		rc = set_dcs_addr($2, NULL);
 		UM_FREE($2);
 		if (rc)
 			return(rc);
diff --git a/usr.sbin/atm/scspd/scsp_hfsm.c b/usr.sbin/atm/scspd/scsp_hfsm.c
index ebd17cd..dc127e7 100644
--- a/usr.sbin/atm/scspd/scsp_hfsm.c
+++ b/usr.sbin/atm/scspd/scsp_hfsm.c
@@ -235,7 +235,7 @@ scsp_hello_act_02(Scsp_dcs *dcsp, Scsp_msg *msg)
 	/*
 	 * Tell the CA FSM that the conection to the DCS is lost
 	 */
-	rc = scsp_cafsm(dcsp, SCSP_CAFSM_HELLO_DOWN, (void *)0);
+	rc = scsp_cafsm(dcsp, SCSP_CAFSM_HELLO_DOWN, NULL);
 
 	/*
 	 * Go to Down state
@@ -350,7 +350,7 @@ scsp_hello_act_04(Scsp_dcs *dcsp, Scsp_msg *msg)
 	/*
 	 * Notify the CA FSM
 	 */
-	rc = scsp_cafsm(dcsp, SCSP_CAFSM_HELLO_DOWN, (void *)0);
+	rc = scsp_cafsm(dcsp, SCSP_CAFSM_HELLO_DOWN, NULL);
 
 	return(rc);
 }
@@ -381,7 +381,7 @@ scsp_hello_act_05(Scsp_dcs *dcsp, Scsp_msg *msg)
 	 * Null message pointer means message decode failed, so
 	 * message must have been invalid.  Go to Waiting state.
 	 */
-	if (msg == (Scsp_msg *)0) {
+	if (msg == NULL) {
 		dcsp->sd_hello_state = SCSP_HFSM_WAITING;
 		HARP_CANCEL(&dcsp->sd_hello_rcv_t);
 		return(0);
@@ -432,7 +432,7 @@ scsp_hello_act_05(Scsp_dcs *dcsp, Scsp_msg *msg)
 			dcsp->sd_hello_state = SCSP_HFSM_BI_DIR;
 			rc = scsp_cafsm(dcsp,
 					SCSP_CAFSM_HELLO_UP,
-					(void *)0);
+					NULL);
 			return(rc);
 		}
 	}
@@ -472,10 +472,10 @@ scsp_hello_act_06(Scsp_dcs *dcsp, Scsp_msg *msg)
 	 * Null message pointer means message decode failed, so
 	 * message must have been invalid.  Go to Waiting state.
 	 */
-	if (msg == (Scsp_msg *)0) {
+	if (msg == NULL) {
 		HARP_CANCEL(&dcsp->sd_hello_rcv_t);
 		dcsp->sd_hello_state = SCSP_HFSM_WAITING;
-		rc = scsp_cafsm(dcsp, SCSP_CAFSM_HELLO_DOWN, (void *)0);
+		rc = scsp_cafsm(dcsp, SCSP_CAFSM_HELLO_DOWN, NULL);
 		return(rc);
 	}
 
@@ -517,7 +517,7 @@ scsp_hello_act_06(Scsp_dcs *dcsp, Scsp_msg *msg)
 			dcsp->sd_hello_state = SCSP_HFSM_WAITING;
 			rc = scsp_cafsm(dcsp,
 					SCSP_CAFSM_HELLO_DOWN,
-					(void *)0);
+					NULL);
 			return(rc);
 		}
 
diff --git a/usr.sbin/atm/scspd/scsp_input.c b/usr.sbin/atm/scspd/scsp_input.c
index 7c5b238..763717a 100644
--- a/usr.sbin/atm/scspd/scsp_input.c
+++ b/usr.sbin/atm/scspd/scsp_input.c
@@ -114,7 +114,7 @@ scsp_free_ca(Scsp_ca *cap)
 	/*
 	 * Return if there's nothing to free
 	 */
-	if (cap == (Scsp_ca *)0)
+	if (cap == NULL)
 		return;
 
 	/*
@@ -150,7 +150,7 @@ scsp_free_csu(Scsp_csu_msg *csup)
 	/*
 	 * Return if there's nothing to free
 	 */
-	if (csup == (Scsp_csu_msg *)0)
+	if (csup == NULL)
 		return;
 
 	/*
@@ -184,7 +184,7 @@ scsp_free_hello(Scsp_hello *hp)
 	/*
 	 * Return if there's nothing to free
 	 */
-	if (hp == (Scsp_hello *)0)
+	if (hp == NULL)
 		return;
 
 	/*
@@ -212,7 +212,7 @@ scsp_free_msg(Scsp_msg *msg)
 	/*
 	 * Return if there's nothing to free
 	 */
-	if (msg == (Scsp_msg *)0)
+	if (msg == NULL)
 		return;
 
 	/*
@@ -960,7 +960,7 @@ scsp_parse_msg(char *buff, int pdu_len)
 {
 	int			ext_off, len, plen;
 	struct scsp_nhdr	*shp;
-	Scsp_msg		*msg = (Scsp_msg *)0;
+	Scsp_msg		*msg = NULL;
 	Scsp_ext		**expp;
 
 	/*
@@ -1064,5 +1064,5 @@ scsp_parse_msg(char *buff, int pdu_len)
 ignore:
 	if (msg)
 		scsp_free_msg(msg);
-	return(Scsp_msg *)0;
+	return NULL;
 }
diff --git a/usr.sbin/atm/scspd/scsp_log.c b/usr.sbin/atm/scspd/scsp_log.c
index 025a57e..f4463d4 100644
--- a/usr.sbin/atm/scspd/scsp_log.c
+++ b/usr.sbin/atm/scspd/scsp_log.c
@@ -69,7 +69,7 @@
 /*
  * Global variables
  */
-FILE	*scsp_trace_file = (FILE *)0;
+FILE	*scsp_trace_file = NULL;
 
 
 /*
@@ -146,7 +146,7 @@ scsp_open_trace(void)
 	 * isn't open and won't try to write to it.
 	 */
 	scsp_trace_file = fopen(fname, "w");
-	if (scsp_trace_file == (FILE *)0) {
+	if (scsp_trace_file == NULL) {
 		scsp_log(LOG_ERR, "Can't open trace file");
 	}
 }
diff --git a/usr.sbin/atm/scspd/scsp_msg.c b/usr.sbin/atm/scspd/scsp_msg.c
index 238d2c9..75ca384 100644
--- a/usr.sbin/atm/scspd/scsp_msg.c
+++ b/usr.sbin/atm/scspd/scsp_msg.c
@@ -161,7 +161,7 @@ scsp_csus_ack(Scsp_dcs *dcsp, Scsp_msg *msg)
 		}
 	}
 
-	if (csusp->csu_csa_rec == (Scsp_csa *)0) {
+	if (csusp->csu_csa_rec == NULL) {
 		/*
 		 * All CSASs in the CSUS message have been
 		 * answered.  Stop the timer and free the
@@ -169,7 +169,7 @@ scsp_csus_ack(Scsp_dcs *dcsp, Scsp_msg *msg)
 		 */
 		HARP_CANCEL(&dcsp->sd_csus_rexmt_t);
 		scsp_free_msg(dcsp->sd_csus_rexmt_msg);
-		dcsp->sd_csus_rexmt_msg = (Scsp_msg *)0;
+		dcsp->sd_csus_rexmt_msg = NULL;
 
 		/*
 		 * If the CRL isn't empty, send another CSUS
@@ -238,13 +238,13 @@ scsp_send_ca(Scsp_dcs *dcsp)
 		cap->ca_m = 1;
 		cap->ca_i = 0;
 		scsp_ca_csas_setup(dcsp, cap);
-		cap->ca_o = dcsp->sd_ca_csas != (Scsp_cse *)0;
+		cap->ca_o = dcsp->sd_ca_csas != NULL;
 		break;
 	case SCSP_CAFSM_SLAVE:
 		cap->ca_m = 0;
 		cap->ca_i = 0;
 		scsp_ca_csas_setup(dcsp, cap);
-		cap->ca_o = dcsp->sd_ca_csas != (Scsp_cse *)0;
+		cap->ca_o = dcsp->sd_ca_csas != NULL;
 		break;
 	default:
 		scsp_log(LOG_ERR, "Invalid state in scsp_send_ca");
@@ -521,8 +521,7 @@ scsp_send_csu_reply(Scsp_dcs *dcsp, Scsp_csa *csap)
 		case SCSP_PROTO_ATMARP:
 			if (csap1->atmarp_data) {
 				UM_FREE(csap1->atmarp_data);
-				csap1->atmarp_data =
-						(Scsp_atmarp_csa *)0;
+				csap1->atmarp_data = NULL;
 			}
 			break;
 		}
diff --git a/usr.sbin/atm/scspd/scsp_output.c b/usr.sbin/atm/scspd/scsp_output.c
index d764b15..aeddbc0 100644
--- a/usr.sbin/atm/scspd/scsp_output.c
+++ b/usr.sbin/atm/scspd/scsp_output.c
@@ -692,7 +692,7 @@ hello_invalid:
 int
 scsp_format_msg(Scsp_dcs *dcsp, Scsp_msg *msg, char **bpp)
 {
-	char			*buff = (char *)0, *e_buff = (char *)0;
+	char			*buff = NULL, *e_buff = NULL;
 	int			buff_len, e_buff_len;
 	int			e_len, len, plen;
 	struct scsp_nhdr	*shp;
@@ -760,7 +760,7 @@ scsp_format_msg(Scsp_dcs *dcsp, Scsp_msg *msg, char **bpp)
 		 */
 		if (!e_len) {
 			UM_FREE(e_buff);
-			e_buff = (char *)0;
+			e_buff = NULL;
 		}
 	}
 	buff_len -= e_len;
@@ -819,7 +819,7 @@ ignore:
 		UM_FREE(buff);
 	if (e_buff)
 		UM_FREE(e_buff);
-	*bpp = (char *)0;
+	*bpp = NULL;
 	return(0);
 }
 
@@ -886,7 +886,7 @@ scsp_send_msg(Scsp_dcs *dcsp, Scsp_msg *msg)
 		/*
 		 * Inform the Hello FSM
 		 */
-		scsp_hfsm(dcsp, SCSP_HFSM_VC_CLOSED, (Scsp_msg *)0);
+		scsp_hfsm(dcsp, SCSP_HFSM_VC_CLOSED, NULL);
 
 		/*
 		 * Set the return code
diff --git a/usr.sbin/atm/scspd/scsp_print.c b/usr.sbin/atm/scspd/scsp_print.c
index a08576a..9fc8480 100644
--- a/usr.sbin/atm/scspd/scsp_print.c
+++ b/usr.sbin/atm/scspd/scsp_print.c
@@ -92,7 +92,7 @@ static Type_name if_msg_types[] = {
 	{ "Cache Update Indication",	SCSP_UPDATE_IND },
 	{ "Cache Update Request",	SCSP_UPDATE_REQ },
 	{ "Cache Update Response",	SCSP_UPDATE_RSP },
-	{ (char *)0,	0 }
+	{ NULL,				0 }
 };
 
 static Type_name msg_types[] = {
@@ -101,7 +101,7 @@ static Type_name msg_types[] = {
 	{ "CSU Reply",		SCSP_CSU_REPLY_MSG },
 	{ "CSU Solicit",	SCSP_CSUS_MSG },
 	{ "Hello",		SCSP_HELLO_MSG },
-	{ (char *)0,		0 }
+	{ NULL,			0 }
 };
 
 static Type_name proto_types[] = {
@@ -110,14 +110,14 @@ static Type_name proto_types[] = {
 	{ "MARS",	SCSP_PROTO_MARS },
 	{ "DHCP",	SCSP_PROTO_DHCP },
 	{ "LNNI",	SCSP_PROTO_LNNI },
-	{ (char *)0,	0 }
+	{ NULL,		0 }
 };
 
 static Type_name ext_types[] = {
 	{ "End of Extensions",	SCSP_EXT_END },
 	{ "Authentication",	SCSP_EXT_AUTH },
 	{ "Vendor Private",	SCSP_EXT_VENDOR },
-	{ (char *)0,		0 }
+	{ NULL,			0 }
 };
 
 static Type_name hfsm_state_names[] = {
@@ -125,7 +125,7 @@ static Type_name hfsm_state_names[] = {
 	{ "Waiting",		SCSP_HFSM_WAITING },
 	{ "Unidirectional",	SCSP_HFSM_UNI_DIR },
 	{ "Bidirectional",	SCSP_HFSM_BI_DIR },
-	{ (char *)0,		0 }
+	{ NULL,			0 }
 };
 
 static Type_name hfsm_event_names[] = {
@@ -134,7 +134,7 @@ static Type_name hfsm_event_names[] = {
 	{ "Hello timer",	SCSP_HFSM_HELLO_T },
 	{ "Receive timer",	SCSP_HFSM_RCV_T },
 	{ "Msg received",	SCSP_HFSM_RCVD },
-	{ (char *)0,		0 }
+	{ NULL,			0 }
 };
 
 static Type_name cafsm_state_names[] = {
@@ -144,7 +144,7 @@ static Type_name cafsm_state_names[] = {
 	{ "Slave",			SCSP_CAFSM_SLAVE },
 	{ "Update cache",		SCSP_CAFSM_UPDATE },
 	{ "Aligned",			SCSP_CAFSM_ALIGNED },
-	{ (char *)0,			0 }
+	{ NULL,				0 }
 };
 
 static Type_name cafsm_event_names[] = {
@@ -159,7 +159,7 @@ static Type_name cafsm_event_names[] = {
 	{ "CSU timer",			SCSP_CAFSM_CSU_T },
 	{ "Cache Update",		SCSP_CAFSM_CACHE_UPD },
 	{ "Cache Response",		SCSP_CAFSM_CACHE_RSP },
-	{ (char *)0,			0 }
+	{ NULL,				0 }
 };
 
 static Type_name cifsm_state_names[] = {
@@ -167,7 +167,7 @@ static Type_name cifsm_state_names[] = {
 	{ "Summarize",	SCSP_CIFSM_SUM },
 	{ "Update",	SCSP_CIFSM_UPD },
 	{ "Aligned",	SCSP_CIFSM_ALIGN },
-	{ (char *)0,			0 }
+	{ NULL,		0 }
 };
 
 static Type_name cifsm_event_names[] = {
@@ -181,14 +181,14 @@ static Type_name cifsm_event_names[] = {
 	{ "CSU Request",	SCSP_CIFSM_CSU_REQ },
 	{ "CSU Reply",		SCSP_CIFSM_CSU_REPLY },
 	{ "CSU Solicit",	SCSP_CIFSM_CSU_SOL },
-	{ (char *)0,			0 }
+	{ NULL,			0 }
 };
 
 static Type_name atmarp_state_names[] = {
 	{ "New",	SCSP_ASTATE_NEW },
 	{ "Updated",	SCSP_ASTATE_UPD },
 	{ "Deleted",	SCSP_ASTATE_DEL },
-	{ (char *)0,	0 }
+	{ NULL,		0 }
 };
 
 
@@ -267,7 +267,7 @@ scsp_type_name(u_char type, Type_name *tbl)
 	/*
 	 * Search the table
 	 */
-	for (i = 0; tbl[i].name != (char *)0 && tbl[i].type != type;
+	for (i = 0; tbl[i].name != NULL && tbl[i].type != type;
 			i++)
 		;
 
@@ -1095,7 +1095,7 @@ print_scsp_dcs(FILE *fp, Scsp_dcs *dcsp)
 	fprintf(fp, "%sCA Retransmit Msg:    %p\n", indent,
 			dcsp->sd_ca_rexmt_msg);
 	fprintf(fp, "%sCSASs to send:        ", indent);
-	if (dcsp->sd_ca_csas == (Scsp_cse *)0) {
+	if (dcsp->sd_ca_csas == NULL) {
 		fprintf(fp, "Empty\n");
 	} else {
 		fprintf(fp, "%p\n", dcsp->sd_ca_csas);
@@ -1103,7 +1103,7 @@ print_scsp_dcs(FILE *fp, Scsp_dcs *dcsp)
 	fprintf(fp, "%sCSUS Rexmit Int:      %d\n", indent,
 			dcsp->sd_csus_rexmt_int);
 	fprintf(fp, "%sCache Request List:   ", indent);
-	if (dcsp->sd_crl == (Scsp_csa *)0) {
+	if (dcsp->sd_crl == NULL) {
 		fprintf(fp, "Empty\n");
 	} else {
 		fprintf(fp, "%p\n", dcsp->sd_crl);
@@ -1208,7 +1208,7 @@ print_scsp_dump(void)
 	 * Open the output file
 	 */
 	df = fopen(fname, "w");
-	if (df == (FILE *)0)
+	if (df == NULL)
 		return;
 
 	/*
diff --git a/usr.sbin/atm/scspd/scsp_socket.c b/usr.sbin/atm/scspd/scsp_socket.c
index b91988c..974532e 100644
--- a/usr.sbin/atm/scspd/scsp_socket.c
+++ b/usr.sbin/atm/scspd/scsp_socket.c
@@ -591,7 +591,7 @@ scsp_dcs_accept(Scsp_server *ssp)
 	sd = accept(ssp->ss_dcs_lsock,
 			(struct sockaddr *)&dcs_sockaddr, &len);
 	if (sd < 0) {
-		return((Scsp_dcs *)0);
+		return(NULL);
 	}
 	if (sd > scsp_max_socket) {
 		scsp_max_socket = sd;
@@ -685,7 +685,7 @@ dcs_accept_fail:
 	 * An error has occured--clean up and return
 	 */
 	close(sd);
-	return((Scsp_dcs *)0);
+	return(NULL);
 }
 
 
@@ -704,7 +704,7 @@ int
 scsp_dcs_read(Scsp_dcs *dcsp)
 {
 	int			len, rc;
-	char			*buff = (char *)0;
+	char			*buff = NULL;
 	Scsp_server		*ssp = dcsp->sd_server;
 	Scsp_msg		*msg;
 
@@ -777,8 +777,7 @@ dcs_read_fail:
 		 * VCC has been closed--pass the event to
 		 * the Hello FSM
 		 */
-		rc = scsp_hfsm(dcsp, SCSP_HFSM_VC_CLOSED,
-				(Scsp_msg *)0);
+		rc = scsp_hfsm(dcsp, SCSP_HFSM_VC_CLOSED, NULL);
 	}
 	if (errno == ECONNREFUSED) {
 		/*
@@ -950,7 +949,7 @@ Scsp_if_msg *
 scsp_if_sock_read(int sd)
 {
 	int		len;
-	char		*buff = (char *)0;
+	char		*buff = NULL;
 	Scsp_if_msg	*msg;
 	Scsp_if_msg_hdr	msg_hdr;
 
@@ -996,7 +995,7 @@ scsp_if_sock_read(int sd)
 socket_read_fail:
 	if (buff)
 		UM_FREE(buff);
-	return((Scsp_if_msg *)0);
+	return(NULL);
 }
 
 
@@ -1115,8 +1114,7 @@ scsp_server_read(Scsp_server *ssp)
 		 * entry from its cache
 		 */
 		dcsp = (Scsp_dcs *)msg->si_tok;
-		rc = scsp_cfsm(dcsp, SCSP_CIFSM_SOL_RSP, (Scsp_msg *)0,
-				msg);
+		rc = scsp_cfsm(dcsp, SCSP_CIFSM_SOL_RSP, NULL, msg);
 		break;
 	case SCSP_UPDATE_REQ:
 		/*
@@ -1127,7 +1125,7 @@ scsp_server_read(Scsp_server *ssp)
 			for (dcsp = ssp->ss_dcs; dcsp;
 					dcsp = dcsp->sd_next) {
 				rc = scsp_cfsm(dcsp, SCSP_CIFSM_UPD_REQ,
-						(Scsp_msg *)0, msg);
+						NULL, msg);
 			}
 		}
 		break;
@@ -1137,8 +1135,7 @@ scsp_server_read(Scsp_server *ssp)
 		 * DCS associated with the request
 		 */
 		dcsp = (Scsp_dcs *)msg->si_tok;
-		rc = scsp_cfsm(dcsp, SCSP_CIFSM_UPD_RSP,
-				(Scsp_msg *)0, msg);
+		rc = scsp_cfsm(dcsp, SCSP_CIFSM_UPD_RSP, NULL, msg);
 		break;
 	default:
 		scsp_log(LOG_ERR, "invalid message type %d from server",
diff --git a/usr.sbin/atm/scspd/scsp_subr.c b/usr.sbin/atm/scspd/scsp_subr.c
index 95b8535..1d3f8d8 100644
--- a/usr.sbin/atm/scspd/scsp_subr.c
+++ b/usr.sbin/atm/scspd/scsp_subr.c
@@ -235,7 +235,7 @@ scsp_dup_cse(Scsp_cse *csep)
 	 * Copy data to the duplicate
 	 */
 	UM_COPY(csep, dupp, sizeof(Scsp_cse));
-	dupp->sc_next = (Scsp_cse *)0;
+	dupp->sc_next = NULL;
 
 	return(dupp);
 }
@@ -270,7 +270,7 @@ scsp_dup_csa(Scsp_csa *csap)
 	 * Copy data to the duplicate
 	 */
 	UM_COPY(csap, dupp, sizeof(Scsp_csa));
-	dupp->next = (Scsp_csa *)0;
+	dupp->next = NULL;
 
 	/*
 	 * Copy protocol-specific data, if it's present
@@ -403,7 +403,7 @@ scsp_dcs_cleanup(Scsp_dcs *dcsp)
 	 */
 	if (dcsp->sd_ca_rexmt_msg) {
 		scsp_free_msg(dcsp->sd_ca_rexmt_msg);
-		dcsp->sd_ca_rexmt_msg = (Scsp_msg *)0;
+		dcsp->sd_ca_rexmt_msg = NULL;
 	}
 	HARP_CANCEL(&dcsp->sd_ca_rexmt_t);
 
@@ -413,7 +413,7 @@ scsp_dcs_cleanup(Scsp_dcs *dcsp)
 	 */
 	if (dcsp->sd_csus_rexmt_msg) {
 		scsp_free_msg(dcsp->sd_csus_rexmt_msg);
-		dcsp->sd_csus_rexmt_msg = (Scsp_msg *)0;
+		dcsp->sd_csus_rexmt_msg = NULL;
 	}
 	HARP_CANCEL(&dcsp->sd_csus_rexmt_t);
 
@@ -669,9 +669,9 @@ scsp_get_server_info(Scsp_server *ssp)
 {
 	int			i, len, mtu, rc, sel;
 	struct atminfreq	air;
-	struct air_netif_rsp	*netif_rsp = (struct air_netif_rsp *)0;
-	struct air_int_rsp	*intf_rsp = (struct air_int_rsp *)0;
-	struct air_cfg_rsp	*cfg_rsp = (struct air_cfg_rsp *)0;
+	struct air_netif_rsp	*netif_rsp = NULL;
+	struct air_int_rsp	*intf_rsp = NULL;
+	struct air_cfg_rsp	*cfg_rsp = NULL;
 	struct sockaddr_in	*ip_addr;
 	Atm_addr_nsap		*anp;
 
diff --git a/usr.sbin/atm/scspd/scsp_timer.c b/usr.sbin/atm/scspd/scsp_timer.c
index 8e3a514..ec91aa3 100644
--- a/usr.sbin/atm/scspd/scsp_timer.c
+++ b/usr.sbin/atm/scspd/scsp_timer.c
@@ -122,7 +122,7 @@ scsp_hello_timeout(Harp_timer *stp)
 	/*
 	 * Call the Hello FSM
 	 */
-	scsp_hfsm(dcsp, SCSP_HFSM_HELLO_T, (Scsp_msg *)0);
+	scsp_hfsm(dcsp, SCSP_HFSM_HELLO_T, NULL);
 
 	return;
 }
@@ -156,7 +156,7 @@ scsp_hello_rcv_timeout(Harp_timer *stp)
 	/*
 	 * Call the Hello FSM
 	 */
-	scsp_hfsm(dcsp, SCSP_HFSM_RCV_T, (void *)0);
+	scsp_hfsm(dcsp, SCSP_HFSM_RCV_T, NULL);
 
 	return;
 }
@@ -186,7 +186,7 @@ scsp_ca_retran_timeout(Harp_timer *stp)
 	/*
 	 * Call the CA FSM
 	 */
-	scsp_cafsm(dcsp, SCSP_CAFSM_CA_T, (void *)0);
+	scsp_cafsm(dcsp, SCSP_CAFSM_CA_T, NULL);
 
 	return;
 }
@@ -216,7 +216,7 @@ scsp_csus_retran_timeout(Harp_timer *stp)
 	/*
 	 * Call the CA FSM
 	 */
-	scsp_cafsm(dcsp, SCSP_CAFSM_CSUS_T, (void *)0);
+	scsp_cafsm(dcsp, SCSP_CAFSM_CSUS_T, NULL);
 
 	return;
 }
diff --git a/usr.sbin/atm/scspd/scspd.c b/usr.sbin/atm/scspd/scspd.c
index 05bf800..fdf6ef4 100644
--- a/usr.sbin/atm/scspd/scspd.c
+++ b/usr.sbin/atm/scspd/scspd.c
@@ -69,10 +69,10 @@
  */
 char		*prog;
 char		*scsp_config_file = SCSPD_CONFIG;
-FILE		*scsp_log_file = (FILE *)0;
+FILE		*scsp_log_file = NULL;
 int		scsp_log_syslog = 0;
-Scsp_server	*scsp_server_head = (Scsp_server *)0;
-Scsp_pending	*scsp_pending_head = (Scsp_pending *)0;
+Scsp_server	*scsp_server_head = NULL;
+Scsp_pending	*scsp_pending_head = NULL;
 int		scsp_max_socket = -1;
 int		scsp_debug_mode = 0;
 int		scsp_trace_mode = 0;
@@ -279,7 +279,7 @@ start_daemon(void)
 	}
 	fd = open(_PATH_TTY, O_RDWR);
 	if (fd >= 0) {
-		ioctl(fd, TIOCNOTTY, (char *)0);
+		ioctl(fd, TIOCNOTTY, NULL);
 		close(fd);
 	}
 
@@ -432,7 +432,7 @@ main(int argc, char **argv)
 		}
 		rc = select(scsp_max_socket + 1, &read_set,
 				&write_set, &except_set,
-				(struct timeval *)0);
+				NULL);
 		if (rc < 0) {
 			/*
 			 * Select error--check for possible signals
@@ -488,7 +488,7 @@ main(int argc, char **argv)
 				if ((dcsp = scsp_find_dcs(i)) != NULL) {
 					rc = scsp_hfsm(dcsp,
 						SCSP_HFSM_VC_ESTAB,
-						(Scsp_msg *)0);
+						NULL);
 				}
 			}
 		}
@@ -505,7 +505,7 @@ main(int argc, char **argv)
 				if (dcsp) {
 					rc = scsp_hfsm(dcsp,
 						SCSP_HFSM_VC_ESTAB,
-						(Scsp_msg *)0);
+						NULL);
 				}
 			}
 		}
diff --git a/usr.sbin/cron/cron/cron.c b/usr.sbin/cron/cron/cron.c
index 7eb548c..d831fe0 100644
--- a/usr.sbin/cron/cron/cron.c
+++ b/usr.sbin/cron/cron/cron.c
@@ -303,7 +303,7 @@ cron_sync(void)
 {
  	struct tm *tm;
 
-	TargetTime = time((time_t*)0);
+	TargetTime = time(NULL);
 	tm = localtime(&TargetTime);
 	TargetTime += (60 - tm->tm_sec);
 }
@@ -319,7 +319,7 @@ cron_sleep(cron_db *db)
 	 */
 
 	for (;;) {
-		seconds_to_wait = (int) (TargetTime - time((time_t*)0));
+		seconds_to_wait = (int) (TargetTime - time(NULL));
 
 		/*
 		 * If the seconds_to_wait value is insane, jump the cron
@@ -381,7 +381,7 @@ sigchld_handler(int x)
 #ifdef POSIX
 		pid = waitpid(-1, &waiter, WNOHANG);
 #else
-		pid = wait3(&waiter, WNOHANG, (struct rusage *)0);
+		pid = wait3(&waiter, WNOHANG, NULL);
 #endif
 		switch (pid) {
 		case -1:
diff --git a/usr.sbin/cron/cron/do_command.c b/usr.sbin/cron/cron/do_command.c
index 8916c86..e56f02b 100644
--- a/usr.sbin/cron/cron/do_command.c
+++ b/usr.sbin/cron/cron/do_command.c
@@ -310,7 +310,7 @@ child_process(entry *e, user *u)
 				_exit(OK_EXIT);
 			}
 # endif /*DEBUGGING*/
-			execle(shell, shell, "-c", e->cmd, (char *)0, e->envp);
+			execle(shell, shell, "-c", e->cmd, NULL, e->envp);
 			warn("execl: couldn't exec `%s'", shell);
 			_exit(ERROR_EXIT);
 		}
diff --git a/usr.sbin/cron/lib/compat.c b/usr.sbin/cron/lib/compat.c
index e6e0220..74cd4aa 100644
--- a/usr.sbin/cron/lib/compat.c
+++ b/usr.sbin/cron/lib/compat.c
@@ -108,7 +108,7 @@ setsid(void)
 #  endif
 	if ((fd = open(_PATH_TTY, 2)) >= 0)
 	{
-		ioctl(fd, TIOCNOTTY, (char*)0);
+		ioctl(fd, TIOCNOTTY, NULL);
 		close(fd);
 	}
 # else /*BSD*/
diff --git a/usr.sbin/devinfo/devinfo.c b/usr.sbin/devinfo/devinfo.c
index f5f9c36..b4bb549 100644
--- a/usr.sbin/devinfo/devinfo.c
+++ b/usr.sbin/devinfo/devinfo.c
@@ -227,7 +227,7 @@ main(int argc, char *argv[])
 		devinfo_foreach_rman(print_rman, NULL);
 	} else {
 		/* print device hierarchy */
-		devinfo_foreach_device_child(root, print_device, (void *)0);
+		devinfo_foreach_device_child(root, print_device, NULL);
 	}
 	return(0);
 }
